"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const path_1 = __importDefault(require("path"));
const _3_0_3_1 = require("@fresha/openapi-model/build/3.0.3");
const ts_morph_1 = require("ts-morph");
const Generator_1 = require("./Generator");
const parser = (yarg) => {
    return yarg
        .string('i')
        .alias('i', 'input')
        .describe('i', 'Input schema')
        .demandOption('i')
        .demandOption('input')
        .string('o')
        .alias('o', 'output')
        .describe('o', 'Output directory (NPM package root)')
        .demandOption('o')
        .demandOption('output')
        .string('json-api')
        .describe('json-api', 'Uses JSON:API extensions')
        .boolean('verbose')
        .describe('verbose', 'prints additional information')
        .boolean('dry-run')
        .describe('dry-run', 'Does not modify files');
};
const handler = (args) => {
    const openapiReader = new _3_0_3_1.OpenAPIReader();
    const openapi = openapiReader.parseFromFile(args.input);
    const tsProject = new ts_morph_1.Project({
        tsConfigFilePath: path_1.default.join(args.output, 'tsconfig.json'),
    });
    const generator = new Generator_1.Generator(openapi, tsProject, {
        outputPath: args.output,
        useJsonApi: !!args.jsonApi,
        verbose: !!args.verbose,
        dryRun: !!args.dryRun,
    });
    generator.run();
};
const register = (argv) => {
    argv.command('client-typescript', '(experimental) generates code for TypeScript clients', parser, handler);
};
exports.register = register;
//# sourceMappingURL=index.js.map